# Class DeepClient<L>

#### Type Parameters

- #### L extends Link<number> = Link<number>

#### Implements

- DeepClientInstance<L>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:213

#####
Index

### Constructors

constructor

### Properties

DeepContext
DeepProvider
apolloClient
client
deep
defaultDeleteName?
defaultInsertName?
defaultSelectName?
defaultUpdateName?
deleteReturning?
filesSelectReturning?
handleAuth?
insertReturning?
linkId?
linksSelectReturning?
minilinks
returning?
selectReturning?
selectorsSelectReturning?
serializeQuery
serializeWhere
silent
table?
token?
unsafe?
updateReturning?
useDeep
useDeepQuery
useDeepSubscription
valuesSelectReturning?
resolveDependency?

### Methods

Traveler
_silent
await
can
delete
guest
id
idLocal
ids
import
insert
jwt
login
logout
name
nameLocal
reserve
select
serial
stringify
subscribe
update
useMinilinksQuery
useMinilinksSubscription
whoami

## Constructors

### constructor

- new DeepClient<L>(options): DeepClient<L>

- #### Type Parameters

  - #### L extends Link<number> = Link<number>

  #### Parameters

  - ##### options: DeepClientOptions<L>

  #### Returns DeepClient<L>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:258

## Properties

### DeepContext

DeepContext: Context<DeepClient<Link<number>>> = DeepContext

Implementation of DeepClientInstance.DeepContext

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:222

### DeepProvider

DeepProvider: ((__namedParameters) => Element) = DeepProvider

#### Type declaration

- - (__namedParameters): Element

  - #### Parameters

    - ##### __namedParameters: {
      apolloClient?: IApolloClient<any>;
      children: any;
      }

      - ##### `Optional` apolloClient?: IApolloClient<any>

      - ##### children: any

    #### Returns Element

Implementation of DeepClientInstance.DeepProvider

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:221

### apolloClient

apolloClient: IApolloClient<any>

Implementation of DeepClientInstance.apolloClient

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:231

### client

client: IApolloClient<any>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:230

### deep

deep: DeepClientInstance<L>

Implementation of DeepClientInstance.deep

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:228

### `Optional` defaultDeleteName

defaultDeleteName?: string

Implementation of DeepClientInstance.defaultDeleteName

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:248

### `Optional` defaultInsertName

defaultInsertName?: string

Implementation of DeepClientInstance.defaultInsertName

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:246

### `Optional` defaultSelectName

defaultSelectName?: string

Implementation of DeepClientInstance.defaultSelectName

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:245

### `Optional` defaultUpdateName

defaultUpdateName?: string

Implementation of DeepClientInstance.defaultUpdateName

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:247

### `Optional` deleteReturning

deleteReturning?: string

Implementation of DeepClientInstance.deleteReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:243

### `Optional` filesSelectReturning

filesSelectReturning?: string

Implementation of DeepClientInstance.filesSelectReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:240

### `Optional` handleAuth

handleAuth?: ((linkId?, token?) => any)

#### Type declaration

- - (linkId?, token?): any

  - #### Parameters

    - ##### `Optional` linkId: number

    - ##### `Optional` token: string

    #### Returns any

Implementation of DeepClientInstance.handleAuth

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:226

### `Optional` insertReturning

insertReturning?: string

Implementation of DeepClientInstance.insertReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:241

### `Optional` linkId

linkId?: number

Implementation of DeepClientInstance.linkId

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:224

### `Optional` linksSelectReturning

linksSelectReturning?: string

Implementation of DeepClientInstance.linksSelectReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:237

### minilinks

minilinks: MinilinksResult<L>

Implementation of DeepClientInstance.minilinks

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:232

### `Optional` returning

returning?: string

Implementation of DeepClientInstance.returning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:234

### `Optional` selectReturning

selectReturning?: string

Implementation of DeepClientInstance.selectReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:236

### `Optional` selectorsSelectReturning

selectorsSelectReturning?: string

Implementation of DeepClientInstance.selectorsSelectReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:239

### serializeQuery

serializeQuery: ((exp, env?) => any) = serializeQuery

#### Type declaration

- - (exp, env?): any

  - #### Parameters

    - ##### exp: any

    - ##### env: string = 'links'

    #### Returns any

Implementation of DeepClientInstance.serializeQuery

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:330

### serializeWhere

serializeWhere: ((exp, env?) => any) = serializeWhere

#### Type declaration

- - (exp, env?): any

  - #### Parameters

    - ##### exp: any

    - ##### env: string = 'links'

    #### Returns any

Implementation of DeepClientInstance.serializeWhere

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:331

### silent

silent: boolean

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:250

### `Optional` table

table?: string

Implementation of DeepClientInstance.table

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:233

### `Optional` token

token?: string

Implementation of DeepClientInstance.token

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:225

### `Optional` unsafe

unsafe?: any

Implementation of DeepClientInstance.unsafe

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:252

### `Optional` updateReturning

updateReturning?: string

Implementation of DeepClientInstance.updateReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:242

### useDeep

useDeep: (() => DeepClient<Link<number>>) = useDeep

#### Type declaration

- - (): DeepClient<Link<number>>

  - #### Returns DeepClient<Link<number>>

Implementation of DeepClientInstance.useDeep

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:220

### useDeepQuery

useDeepQuery: (<Table, LL>(query, options?) => {
data?: LL[];
error?: any;
loading: boolean;
}) = useDeepQuery

#### Type declaration

- - <Table, LL>(query, options?): {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

  - #### Type Parameters

    - #### Table extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

    - #### LL = Link<number>

    #### Parameters

    - ##### query: QueryLink

    - ##### `Optional` options: {
      mini?: string;
      name?: string;
      returning?: string;
      table?: Table;
      tableNamePostfix?: string;
      variables?: any;
      }

      - ##### `Optional` mini?: string

      - ##### `Optional` name?: string

      - ##### `Optional` returning?: string

      - ##### `Optional` table?: Table

      - ##### `Optional` tableNamePostfix?: string

      - ##### `Optional` variables?: any

    #### Returns {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

    - ##### `Optional` data?: LL[]

    - ##### `Optional` error?: any

    - ##### loading: boolean

Implementation of DeepClientInstance.useDeepQuery

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:217

### useDeepSubscription

useDeepSubscription: (<Table, LL>(query, options?) => UseDeepSubscriptionResult<LL>) = useDeepSubscription

#### Type declaration

- - <Table, LL>(query, options?): UseDeepSubscriptionResult<LL>

  - #### Type Parameters

    - #### Table extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

    - #### LL = Link<number>

    #### Parameters

    - ##### query: QueryLink

    - ##### `Optional` options: {
      mini?: string;
      name?: string;
      returning?: string;
      table?: Table;
      tableNamePostfix?: string;
      variables?: any;
      }

      - ##### `Optional` mini?: string

      - ##### `Optional` name?: string

      - ##### `Optional` returning?: string

      - ##### `Optional` table?: Table

      - ##### `Optional` tableNamePostfix?: string

      - ##### `Optional` variables?: any

    #### Returns UseDeepSubscriptionResult<LL>

Implementation of DeepClientInstance.useDeepSubscription

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:216

### `Optional` valuesSelectReturning

valuesSelectReturning?: string

Implementation of DeepClientInstance.valuesSelectReturning

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:238

### `Static` `Optional` resolveDependency

resolveDependency?: ((path) => Promise<any>)

#### Type declaration

- - (path): Promise<any>

  - #### Parameters

    - ##### path: string

    #### Returns Promise<any>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:214

## Methods

### Traveler

- Traveler(links): Traveler

- #### Parameters

  - ##### links: Link<number>[]

  #### Returns Traveler

  Implementation of DeepClientInstance.Traveler

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:804

### _silent

- _silent(options?): boolean

- #### Parameters

  - ##### options: Partial<{
    silent?: boolean;
    }> = {}

  #### Returns boolean

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:254

### await

- await(id, options?): Promise<any>

- #### Parameters

  - ##### id: number

  - ##### options: {
    results: boolean;
    } = ...

    - ##### results: boolean

  #### Returns Promise<any>

  Implementation of DeepClientInstance.await

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:581

### can

- can(objectIds, subjectIds, actionIds, userIds?): Promise<boolean>

- #### Parameters

  - ##### objectIds: number | number[]

  - ##### subjectIds: number | number[]

  - ##### actionIds: number | number[]

  - ##### userIds: number | number[] = ...

  #### Returns Promise<boolean>

  Implementation of DeepClientInstance.can

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:752

### delete

- delete<TTable>(exp, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Implementation of DeepClientInstance.delete

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:491

### guest

- guest(options?): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientGuestOptions = {}

  #### Returns Promise<DeepClientAuthResult>

  Implementation of DeepClientInstance.guest

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:696

### id

- id(start, ...path): Promise<number>

- Find id of link by packageName/id as first argument, and Contain value (name) as path items.

  #### Parameters

  - ##### start: QueryLink | DeepClientStartItem

  - ##### `Rest` ...path: DeepClientPathItem[]

  #### Returns Promise<number>

  number

  #### Description

  Thows error if id is not found. You can set last argument true, for disable throwing error.

  Implementation of DeepClientInstance.id

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:597

### idLocal

- idLocal(start, ...path): number

- #### Parameters

  - ##### start: DeepClientStartItem

  - ##### `Rest` ...path: DeepClientPathItem[]

  #### Returns number

  Implementation of DeepClientInstance.idLocal

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:666

### ids

- ids(...paths): Promise<any>

- This function fetches the corresponding IDs from the Deep for each specified path.

  #### Parameters

  - ##### `Rest` ...paths: [DeepClientStartItem, ...DeepClientPathItem[]][]

    An array of [start, ...path] tuples. Each tuple specifies a path to a link, where 'start' is the package name or id and ...path further specifies the path to the id using Contain link values (names).

  #### Returns Promise<any>

  - Returns a Promise that resolves to an object. The object has keys corresponding to the package name or id of each path. The value for each package key is an object where keys are the items in the corresponding path, and the values are the IDs retrieved from the Deep.

  #### Async

  #### Function

  ids

  #### Throws

  Will throw an error if the id retrieval fails in `this.id()` function.

  #### Example

        const ids = await deep.ids([
          ['@deep-foundation/core', 'Package'],
          ['@deep-foundation/core', 'PackageVersion']
        ]);

        // Outputs
        // {
        //   "@deep-foundation/core": {
        //     "Package": 2,
        //     "PackageVersion": 46
        //   }
        // }

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:648

### import

- import(path): Promise<any>

- #### Parameters

  - ##### path: string

  #### Returns Promise<any>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:786

### insert

- insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  - #### LL = L

  #### Parameters

  - ##### objects: InsertObjects<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Implementation of DeepClientInstance.insert

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:440

### jwt

- jwt(options): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  Implementation of DeepClientInstance.jwt

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:706

### login

- login(options): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  Implementation of DeepClientInstance.login

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:740

### logout

- logout(): Promise<DeepClientAuthResult>

- #### Returns Promise<DeepClientAuthResult>

  Implementation of DeepClientInstance.logout

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:747

### name

- name(input): Promise<string>

- #### Parameters

  - ##### input: number | Link<number>

  #### Returns Promise<string>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:762

### nameLocal

- nameLocal(input): string

- #### Parameters

  - ##### input: number | Link<number>

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:778

### reserve

- reserve<LL>(count): Promise<number[]>

- #### Type Parameters

  - #### LL = L

  #### Parameters

  - ##### count: number

  #### Returns Promise<number[]>

  Implementation of DeepClientInstance.reserve

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:577

### select

- select<TTable, LL>(exp, options?): Promise<DeepClientResult<LL[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

  - #### LL = L

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: ReadOptions<TTable>

  #### Returns Promise<DeepClientResult<LL[]>>

  Implementation of DeepClientInstance.select

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:333

### serial

- serial(__namedParameters): Promise<DeepClientResult<{
  id: number;
  }[]>>

- #### Parameters

  - ##### __namedParameters: AsyncSerialParams

  #### Returns Promise<DeepClientResult<{
  id: number;
  }[]>>

  Implementation of DeepClientInstance.serial

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:514

### stringify

- stringify(any?): string

- #### Parameters

  - ##### `Optional` any: any

  #### Returns string

  Implementation of DeepClientInstance.stringify

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:319

### subscribe

- subscribe<TTable, LL>(exp, options?): Observable<LL[]>

- deep.subscribe

  #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

  - #### LL = L

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: ReadOptions<TTable>

  #### Returns Observable<LL[]>

  #### Example

      deep.subscribe({ up: { link_id: 380 } }).subscribe({ next: (links) => {}, error: (err) => {} });

  Implementation of DeepClientInstance.subscribe

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:385

### update

- update<TTable>(exp, value, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### value: UpdateValue<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Implementation of DeepClientInstance.update

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:466

### useMinilinksQuery

- useMinilinksQuery(query): any

- #### Parameters

  - ##### query: QueryLink

  #### Returns any

  Implementation of DeepClientInstance.useMinilinksQuery

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:218

### useMinilinksSubscription

- useMinilinksSubscription(query): any

- #### Parameters

  - ##### query: QueryLink

  #### Returns any

  Implementation of DeepClientInstance.useMinilinksSubscription

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:219

### whoami

- whoami(): Promise<number>

- Return is of current authorized user linkId. Refill client.linkId and return.

  #### Returns Promise<number>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:734

Generated using TypeDoc